$crystal = 12000000
$regfile = "89C2051.dat"
'--------------Przypisanie aliasw portw----------------
'Diody nadawcze ired podlaczone przez tranzystor pnp
Ired Alias P3.3
'zielona dioda led
Dled Alias P3.5
'podlaczone do wejscia nadajnika radiowego
Nadajnik Alias P3.4
'jumpery
Jp1 Alias P3.0
Jp2 Alias P3.2
'przyciski
Sw1 Alias P3.7
Sw2 Alias P1.3
Sw3 Alias P3.1
Sw4 Alias P1.2
'sekwencje wybierajce poszczeglne kanaly
Const Wybierz1 = &B10001101
Const Wybierz2 = &B00011101
Const Wybierz3 = &B00101101
Const Wybierz4 = &B01001101
P1 = &B00001101
P3 = &B11101111

'-----------deklaracje zmiennych-------------
Dim Licznik As Byte , Odczytane As Byte , Kalibracja As Word , Temp As Word
Dim Blad As Bit , Xk3 As Bit , Xk4 As Bit , Wbit As Bit
Dim Adres As Byte , Komenda As Byte , Licznik36 As Byte
Dim K1 As Byte , K2 As Byte , K3 As Byte , K4 As Byte , Przyciski As Byte
Blad = 0
Kalibracja = 64

'-------kalibracja---------

'odczyt pierwszego kanalu - kalibracja
'wlacz odpowiedni klucz w ukladzie 4066
P1 = Wybierz1
Gosub Podlacz
'tu nastepuje wlasciwa kalibracja - joystick musi byc ustawiony w pozycji srodkowej
'w kazdym nastepnym odczycie pozycji tej odpowiada wtedy 128
Kalibracja = 8192 / Temp

'odczyt drugiego kanalu
P1 = Wybierz2
Gosub Podlacz
'program przechodzi dalej tylko, jezeli podlaczone sa przynajmniej dwa kanaly joysticka

'odczyt trzeciego kanalu
P1 = Wybierz3
Gosub Odczyt
Xk3 = Not Blad
'jesli nastapil blad odczytu, to znaczy ze nie ma podlaczonego 3 kanalu - wiec potem nie jest juz odczytywany

'odczyt czwartego kanalu
P1 = Wybierz4
Gosub Odczyt
Xk4 = Not Blad

'------glowna petla------
Do
'kolejny odczyt wszystkich kanalow
P1 = Wybierz1
Gosub Odczyt
K1 = Odczytane
P1 = Wybierz2
Gosub Odczyt
K2 = Odczytane
If Xk3 = 1 Then
  P1 = Wybierz3
  Gosub Odczyt
  K3 = Odczytane
End If
If Xk4 = 1 Then
  P1 = Wybierz4
  Gosub Odczyt
  K4 = Odczytane
End If
Przyciski.0 = Sw1
Przyciski.1 = Sw2
Przyciski.2 = Sw3
Przyciski.4 = Sw4
'wysylanie danych
'zastosowane s kolejne adresy 27-30
Adres = 27
If Jp1 = 1 Then
  'tryb 1 - kanaly kodowane 3 bitowo - pod adres 27
  'w wersji podstawowej 2 kanaly 3bitowe
  'formatowanie danych do wyslania
  'ze zmiennej 8bitowej robimy 3 bitowa (oba kanaly): xxxxxxxx ->00000xxx
  Shift K1 , Right , 5
  Shift K2 , Right , 5
  'teraz przesuwamy drugi kanal o 3 bity w lewo: 00000yyy -> 00yyy000
  Shift K2 , Left , 3
  'i laczymy dane z obu kanalow razem: 00000xxx or 00yyy000 ->00yyyxxx
  Komenda = K1 Or K2
  'potem wysylamy to co z tego wyszlo
  Gosub Sendrc5
  If Jp2 = 0 Then
    'wersja rozszerzona
    'dodatkowo trzeci kanal i 3 przyciski - adres 28
    'znowu formatownie
    Shift K3 , Right , 5
    'zerujemy wartosc czwartego przycisku
    Przyciski.3 = 0
    'i przesuwamy 3 pozostale bity
    Shift Przyciski , Left , 3
    'ktore potem laczymy z danymi trzeciego kanalu
    Komenda = K3 Or Przyciski
    Incr Adres
    Gosub Sendrc5
    'dodatkowe opuznienie, zmniejsza pobor pradu przy trybie IRED
    Waitms 100
  End If
Else
  'jumper jp1 zwarty - tryb drugi - 5bitowy
  'wersja podstawowa - 2 kanaly + 2 przyciski pod adresy 27,28
  'i znowu formatownie, podobnie jak wczesniej
  Shift K1 , Right , 3
  Komenda = K1
  Komenda.5 = Przyciski.0
  Gosub Sendrc5
  Incr Adres
  Shift K2 , Right , 3
  Komenda = K2
  Komenda.5 = Przyciski.1
  Gosub Sendrc5
  If Jp2 = 0 Then
    'wersja rozszerzona
    'wszystkie 4 kanaly i 4 przyciski - adresy 27-30
    Incr Adres
    Shift K3 , Right , 3
    Komenda = K3
    Komenda.5 = Przyciski.2
    Gosub Sendrc5
    Incr Adres
    Shift K4 , Right , 3
    Komenda = K4
    Komenda.5 = Przyciski.3
    Gosub Sendrc5
  End If
End If

Loop

Odczyt:
'oczekiwanie na rozladowanie kondensatora pomiarowego
Waitms 2
Odczytane = 255
$asm
clr {blad}
Setb P1.1
Zliczaj:
jnb p3.6,konieczliczania
Nop ; Nop
djnz {odczytane},zliczaj
setb {blad}
Konieczliczania:
clr p1.1
$end Asm
If Blad = 0 Then
  'odczyt OK
  'poniewaz liczylismy od gory, a chcemy wartosc od 0, nalezy wykonac dzialanie
  'odczytane=255-odczytane, czyli prosciej:
  Odczytane = Not Odczytane
  'mnozenie przez zmienna kalibracyjna
  'wynik w zmiennej pomocniczej typu Word
  Temp = Odczytane * Kalibracja
  Shift Temp , Right , 6
  'ale wynik i tak przepisujemy z powrotem do zmiennej typu Byte
  Odczytane = Temp
Else
  'jezeli jednak wystapil blad, to musimy podac jakas wartosc
  Odczytane = 255
End If
'tutaj nastepuje formatowanie wyniku do postaci:
'1 bit - kierunek wychylenia, reszta - wychylenie od polozenia srodkowego
If Odczytane < 128 Then
Odczytane = 128 - Odczytane
End If
Return

Sendrc5:
$asm
clr {dled}
setb {wbit}
'wysylanie dwoch bitow startu i jednego toggle=0
acall wyslijbit
acall wyslijbit
clr wbit
acall wyslijbit
'wysylanie adresu
mov a,{adres}
mov c,acc.4
mov {wbit},c
acall wyslijbit
mov c,acc.3
mov {wbit},c
acall wyslijbit
mov c,acc.2
mov {wbit},c
acall wyslijbit
mov c,acc.1
mov {wbit},c
acall wyslijbit
mov c,acc.0
mov {wbit},c
acall wyslijbit
'wysylanie komendy
mov a, {komenda}
mov c,acc.5
mov {wbit},c
acall wyslijbit
mov c,acc.4
mov {wbit},c
acall wyslijbit
mov c,acc.3
mov {wbit},c
acall wyslijbit
mov c,acc.2
mov {wbit},c
acall wyslijbit
mov c,acc.1
mov {wbit},c
acall wyslijbit
mov c,acc.0
mov {wbit},c
acall wyslijbit
setb {dled}
clr {nadajnik}
$end Asm
'opoznienie po kazdym wyslaniu, po to, zeby odbiornik mogl przetrawic dane
Waitms 50
Return

$asm
Wyslijbit:
mov {licznik36},#65
mov c,wbit
cpl c
mov {nadajnik},c
Wys1:
orl c,wbit
mov {ired},c
'oczekiwanie przez 8 cykli
Nop ; Nop ; Nop ; Nop ; Nop ; Nop ; Nop ; Nop
cpl c
djnz {licznik36},wys1
mov c,wbit
mov {nadajnik},c
mov {licznik36},#65
Wys2:
orl c,/wbit
mov {ired},c
Nop ; Nop ; Nop ; Nop ; Nop ; Nop ; Nop ; Nop
cpl c
djnz {licznik36},wys2
setb {ired}
ret
$end Asm

Podlacz:
Do
Gosub Odczyt
Dled = 0
Waitms 20
Dled = 1
Wait 1
'czekaj na podlaczenie joysticka
Loop Until Blad = 0
Return